!! This file is autogenerated by the preprocessor pre_stics based on the file ./doc/profil.csv
module get_soil_values_m
  use messages
  use Stics
  use Plante
  use Sol
  use soil_computation_m
   implicit none
contains
   function get_soil_values(logger, variable_name, sc, plant, soil) result(soil_values)
      type(logger_), intent(in) :: logger
      character(*), intent(in) :: variable_name
      type(Stics_Communs_), intent(in) :: sc
      type(Plante_), intent(in) :: plant
      type(Sol_), intent(in) :: soil

      real, allocatable :: soil_values(:)

      select case (variable_name)
        case ('C_allresidues')
          ! total amount of C for all residues by layer
          ! kg.ha-1
          soil_values = sc%C_allresidues(1:soil%profsol)
        case ('Chum')
          ! Quantity of C in humus in each layer
          ! kg.ha-1
          soil_values = sc%Chum(1:soil%profsol)
        case ('efnrac')
          ! effect of mineral nitrogen on the roots
          ! 0-1
          soil_values = plant%efnrac(1:soil%profsol)
        case ('humirac')
          ! soil dryness on the roots
          ! 0-1
          soil_values = plant%humirac(1:soil%profsol)
        case ('hur')
          ! soil water content
          ! mm.cm-1
          soil_values = sc%hur(1:soil%profsol)
        case ('husup_by_cm')
          ! water drainage under each layer of 1 cm
          ! mm
          soil_values = sc%husup_by_cm(1:soil%profsol)
        case ('lracz')
          ! efficient root density profile
          ! cm.cm-3sol
          soil_values = plant%lracz(1:soil%profsol)
        case ('msrac')
          ! biomass of roots
          ! t.ha-1
          soil_values = compute_msrac(sc, plant, soil)
        case ('N_allresidues')
          ! total amount of N for all residues by layer
          ! kgN.ha-1
          soil_values = sc%N_allresidues(1:soil%profsol)
        case ('Nhum')
          ! Quantity of N in humus in each layer
          ! kgN.ha-1
          soil_values = sc%Nhum(1:soil%profsol)
        case ('nit')
          ! profile of soil nitrates
          ! kgN.ha-1
          soil_values = soil%nit(1:soil%profsol)
        case ('p_rl')
          ! percentage of root length in relation to total length
          ! %
          soil_values = compute_p_rl(sc, plant, soil)
        case ('p_rlf')
          ! percentage of fine roots
          ! %
          soil_values = compute_p_rlf(sc, plant, soil)
        case ('p_rlg')
          ! percentage of coarse roots
          ! %
          soil_values = compute_p_rlg(sc, plant, soil)
        case ('rl')
          ! length of coarse roots plus length of fine roots
          ! cm.cm-2sol
          soil_values = compute_rl(sc, plant, soil)
        case ('rlf')
          ! length of fine roots
          ! cm.cm-2sol
          soil_values = plant%rlf(1:soil%profsol)
        case ('rlg')
          ! length of coarse roots
          ! cm.cm-2sol
          soil_values = plant%rlg(1:soil%profsol)
        case ('tsol')
          ! profile of soil temperature
          ! degrees.C
          soil_values = sc%tsol(1:soil%profsol)
      case default
        call exit_error(logger, "Unknown variable ["//variable_name// &
          "] in soil profile. Check that the name in prof.mod is correct.")
      end select
  end function
end module

